<?php

// app/code/local/Envato/Custompaymentmethod/Helper/Data.php
class Payzoff_mygateway_Helper_Data extends Mage_Core_Helper_Abstract
{
    function getPaymentGatewayUrl()
    {
        return Mage::getUrl( 'custompaymentmethod/payment/gateway', array( '_secure' => false ) );
    }

    /**
     * validate transaction is coming from payzoff only
     *
     * @param $secret_code
     * @param $data
     *
     * @return bool
     */
    public function validate_transaction( $data )
    {
        if ( empty($data) )
        {
            return false;
        }

        // Secrete code which was stored somewhere during first call to payzoff using curl
        // for test purposes, we can set this code to manually, but when complete code will be implented this can be removed.
        //$secret_code = md5( $data[''] );

        $api_key  = Mage::getStoreConfig( 'payment/mygateway/payzoff_api' );
        $sign_key = Mage::getStoreConfig( 'payment/mygateway/payzoff_secret' );

        $signature = md5( $api_key . $data['amount'] . $data['seller_transaction_id'] . $sign_key );

        // Get information from database using the seller transaction id received from the payzoff
        // this process is used to fetch secret_code from the database to verify call is actually
        // from the payzoff
        $trans_info = Mage::getModel('mygateway/transaction')->load($data['seller_transaction_id'], 'quote_id');

        if ( $signature == $data['payment_hash'] && $trans_info->getSecretCode() == $data['secret_code'] )
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    /**
     * Gets error messages against status codes received from payzoff
     *
     * @param $code
     *
     * @return string
     */
    public function getErrorMessage($code)
    {
        $messages = Array(
                0  => 'No error, request successful',
                1  => 'Empty API key. You may obtain it in your Profile',
                2  => 'API key is invalid. Make sure you put correct API key',
                3  => 'You are not authorized to perform this action',
                4  => 'You must pass transaction amount',
                5  => 'You are only allowed to perform your request via SSL',
                6  => 'We require seller transaction ID',
                7  => 'We already got transaction with current transaction ID',
                8  => 'We require to set return_url, result_url and fail_url',
                9  => 'We use action to identify what request you are trying to perform',
                10 => 'Signature is wrong. Make sure you generate correct',
                11 => 'Currency is not defined, add currency code',
                12 => 'No email, name and birthday defined'
            );
        if ( array_key_exists( $code, $messages ) )
        {
            return $messages[$code];
        }
        else
        {
            return 'Invalid error code, please contact administrator';
        }
    }

}